/*
 * dx.c -- 2HD(8sec) x^C[Wt@Cwt@C𒊏o܂
 * dx.c,v 1.4 1995-05-02 04:01:06+0900 kyoko Exp
 * Copyright (C) 1995 fubuki
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <time.h>
#include  <utime.h>
#include  <ctype.h>
#include  <mbctype.h>
#include  <signal.h>
#include  <unistd.h>
#include  <errno.h>
#include  <sys/dos.h>
#include  <sys/stat.h>

const char	*rcsid = "@(#)dx.c,v 1.4 1995-05-02 04:01:06+0900 kyoko Exp";
const char	*rcsname = "amy";

#define	TRUE			1
#define	FALSE			0
#define	SENTINEL		0
#define	EOS				'\0'
#define	SLASH			"\\"
#define ESCAPE			"\\"

typedef	unsigned char	UC;
typedef	unsigned short	US;
typedef	unsigned long	UL;

#ifndef __match_h__
#define __match_h__

#define ANYSTRING		'*'
#define ANYCHAR			'?'
#define LBRACKET		'['
#define RBRACKET		']'
#define RANGE			'-'
#define UNSET			'!'
#define UNSET_OLD		'^'
#define LBRACE			'{'
#define RBRACE			'}'

int		escape_char = '\\';

#define	GETCHAR(s, ignore_case) ({		\
	int		_C;							\
	if (ismbblead(*s)) {				\
		_C = (((UC)s[0] << 8)| (UC)s[1]); \
		s += 2;							\
	} else {							\
		if (ignore_case)				\
			_C = toupper(s[0]);			\
		else							\
			_C = s[0];					\
		s++;							\
	}									\
	(_C);								\
})

typedef enum	{ SENSITIVE, INSENSITIVE } CASE;
typedef	char	REGEX;

int	match(const char *string, const REGEX *regex, CASE icase);

#endif  /* __match_h__ */


#ifndef __twentyone_through_h__
#define __twentyone_through_h__

#define	_THROUGH		0x01
#define	_THROUGH_S		0x02
#define	_THROUGH_CTRL	0x04
#define	_THROUGH_P		0x08

#define	S	_THROUGH_S
#define	P	_THROUGH_P
#define	A	(_THROUGH|_THROUGH_S|_THROUGH_P)
#define	SS	_THROUGH_CTRL

static UC _throughmap[128] = {
	 0,SS,SS,SS,SS,SS,SS,SS, 0, 0,SS,SS,SS,SS,SS,SS,
	SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,SS,

	 0, A, S, A, A, A, A, S, A, A, 0, S, S, S, P, 0,
	 A, A, A, A, A, A, A, A, A, A, 0, S, S, S, S, 0,

	 A, A, A, A, A, A, A, A, A, A, A, A, A, A, A, A,
	 A, A, A, A, A, A, A, A, A, A, A, S, 0, S, A, A,

	 A, A, A, A, A, A, A, A, A, A, A, A, A, A, A, A,
	 A, A, A, A, A, A, A, A, A, A, A, A, S, A, A,SS
	/*											 ^^
							DELETE  Human 3.02 ł
							TwentyOne Ȃł open ł邪
							s\ɂȂ̂ŊOĂ
	 */
};

#undef	S
#undef	P
#undef	A
#undef	SS

#define	TWENTYONE_off	_THROUGH
#define	TWENTYONE_S		(_THROUGH|_THROUGH_S)
#define	TWENTYONE_SS	(TWENTYONE_S|_THROUGH_CTRL)	/* through contrl code */
#define	TWENTYONE_P		(TWENTYONE_S|_THROUGH_P)	/* +P Ăz +S Ă? */

#define	ISTHROUGH(n)	(((UC)n & 0x80)||(_throughmap[(UC)n & 0x7f] & _twentyone))

static int	_twentyone = TWENTYONE_off;

#endif  /* __twentyone_through_h__ */


/* Micro soft disk type attribute */
#define	MS_RED			0001
#define	MS_HID			0002
#define	MS_SYS			0004
#define	MS_VOL			0010
#define	MS_DIR			0020
#define	MS_REG			0040
/* Human FSW Localy bit */
#define	MS_LNK			0100
#define	MS_EXE			0200

#define	MAXPATTERN		2048
#define	FATTERM12		0xfff
#define	FDFATMAGIC		"\xfe\xff\xff"
#define	SECTOR			8
#define	BLOCKSIZE		1024
#define	ROOT_ENTRY		192
#define	TRACK_COUNT		170
#define	OFFSET_MAX		(SECTOR * TRACK_COUNT)
#define	DIFCMAGIC		"DIFC HEADER  "
#define	SEEKPTR(o)		((seektable[(o)] * BLOCKSIZE) + dimoffset)
enum					{ DIM_2HD_ID = 0 };
typedef enum			{ UNKNOWN, ALLOVER, DIM } FILETYPE;

#define	ISMONTHS(m)		((m) >= 0 && (m) <= 11)
#define	ISSLASH(p)		('\\' == (p) || '/' == (p))
#define	ISPATH(p)		(ISSLASH(p) || ':' == (p))
#define	ISDRIVE(p)		(isalpha(p[0]) && ':' == (p[1]))
#define	_XCHMOD(n, a)	(_dos_chmod(n, a))
#define	_XMKDIR(n)		(_dos_mkdir(n))
#define	POPATTR(n)		(attrstack[n].attr)
#define	POPTIME(n)		(attrstack[n].time)
#define	BCD2DIGIT(n)	(((UC)n & 0xf) + ((((UC)n & 0xf0) >> 4) * 10))

#define	PUSHATTR(p) {					\
	attrstack[indent].attr =			\
		p->attr;						\
	attrstack[indent].time =			\
		REGSTAMP(p);					\
}

#define	PUTATTR(p) {					\
	putchar(MS_DIR & p ? 'd' :			\
			MS_VOL & p ? 'v' :			\
			MS_LNK & p ? 'l' : '-');	\
	putchar(MS_REG & p ? 'a' : '-');	\
	putchar(MS_SYS & p ? 's' : '-');	\
	putchar(MS_HID & p ? 'h' : '-');	\
	putchar('r');						\
	putchar(MS_RED & p ? '-' : 'w');	\
	putchar(MS_EXE & p ? 'x' : '-');	\
}

#define	PUT_EXTMESSAGE(name, mes) {		\
	if (!qopt) {						\
		if (EOS != *outputdir) {		\
			fputs(outputdir, stderr);	\
			fputs(slash, stderr);		\
		}								\
		fprintf(stderr, "%s: %s",		\
			name, mes);					\
	}									\
}

#define	REGLEN(length) ({				\
	UL	_L;								\
	_L  = length >> 24;					\
	_L  += (length >> 8) & 0xff00;		\
	_L  += (length << 8) & 0xff0000;	\
	_L  += (length << 24) & 0xff000000;	\
	(_L);								\
})

#define	REGSTAMP(p) ({					\
	UL	_T;								\
	_T = ((p->date << 8) |				\
		(p->date >> 8)) & 0xffff;		\
	_T <<= 16;							\
	_T |= ((p->time << 8) |				\
		(p->time >> 8)) & 0xffff;		\
	(_T);								\
})

typedef struct {
	char	name[8];
	char	ext[3];
	char	attr;
	char	extname[10];
	US		time;
	US		date;
	US		start_fat;
	UL		length;
} DIRENT;

typedef struct {
	char	attr;
	UL		time;
} ATRSTK;

/* DOS call 𒼐ڌĂł֐ under score Ŏn܂Ă܂ */
int			exdir(DIRENT *pool, const char *path, const REGEX **reg, int count);
int			getfatlink(const int fatno, const char *fat);
void		readdirs(int fat, const char *path, const REGEX **reg, int count);
int			chkarg(int argc, char **argv, char **file);
void		usage(void);
int			writefile(const DIRENT *pool, char *name);
time_t		maketime(const DIRENT *pool);
void		*xmalloc(size_t foo);
void		regtime(struct tm *tp, const DIRENT *pool);
int			xfseek(FILE *fp, long offset, int whence);
int			xfread(void *buffer, size_t size, size_t so, FILE *fp);
int			xfwrite(void *buffer, size_t size, size_t so, FILE *fp);
void		xfclose(FILE *fp);
char		*getname(const char *p);
void		_xmkdir(const char *buffer, const char *last, int stack);
void		_signalhandler(int sig);
void		_xutime(const char *name, const UL time);
char		*_getpwd(void);
int			xexit(const int n);
void		xchdir(const char *path);
char		*exist_interactive(char *name);
void		ifdim2hd(int a, const char *name);
void		make_seek_table(void);
char		*chopslash(char *name);
int			regname(char *p, const int dotpoint);
void		put_dim_info(const char *fat);

static const char	*months[] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
	"---"
};

char		*This;
char		*Fat;
FILE		*fp;
int			indent = 0;
char		*slash;
char		newname[PATH_MAX];
char		*wfile = "";
ATRSTK		*attrstack;
char		*tracktable;
short		*seektable;
int			dimoffset = 0;
FILETYPE	force = UNKNOWN;

char		*outputdir = "";

CASE		iopt = SENSITIVE;
int			jopt = FALSE;
int			xopt = FALSE;
int			fopt = FALSE;
int			qopt = FALSE;
int			vopt = FALSE;
int			oopt = FALSE;
int			popt = FALSE;
int			nopt = FALSE;
int			once = FALSE;
int			copt = FALSE;
int			Dopt = FALSE;
int			Fopt = FALSE;
int			topt = FALSE;
int			Copt = FALSE;

int
main(int argc, char **argv)
{
	DIRENT	*pool = xmalloc(sizeof(DIRENT) * (ROOT_ENTRY + 1));
	char	*file[MAXPATTERN];
	char	imagefile[PATH_MAX];
	int		count;

	slash = getenv("SLASH") ?: SLASH;
	/* setup `escape_char' */
	{
		UC *e = (UC *)(getenv("ESCAPE") ?: ESCAPE);
		escape_char = GETCHAR(e, FALSE);
	}
	This  = getname(argv[0]);
	Fat   = xmalloc(BLOCKSIZE * 2);
	attrstack = xmalloc(sizeof(ATRSTK) * 128);
	pool[ROOT_ENTRY].name[0] = SENTINEL;
#if TWENTYONE_OPTS_EXIST
	{
		long	TwentyOneOptions(void);
		long	tst = TwentyOneOptions();
		if (04000000000 & tst)
			_twentyone = TWENTYONE_S;
		if (02000000000 & tst)
			_twentyone = TWENTYONE_P;
	}
#endif /* TWENTYONE_OPTS_EXIST */
	if (file[0] = getenv("DXINIT")) chkarg(1, file, file);

	if (0 == (count = chkarg(--argc, ++argv, file))) {
		usage();
		/* NOTREACHED */
	}
	if (0 == --count) {
		count++;
		file[1] = "*";
		/* xopt = FALSE; */
	}
	switch(force) {

	case	DIM:
		Dopt = TRUE;
		break;
	case	ALLOVER:
		Dopt = FALSE;
		break;
	default:
		break;

	}
	if (EOS != *outputdir) {
		if (!ISDRIVE(file[0]) && !ISSLASH(*file[0])) {
			strcpy(imagefile, _getpwd());
			strcat(imagefile, slash);
			strcat(imagefile, file[0]);
		} else
			strcpy(imagefile, file[0]);
		xchdir(outputdir);
	} else
		strcpy(imagefile, file[0]);

	if (NULL == (fp = fopen(imagefile, "rb"))) {
		fprintf(stderr, "%s: file can't open: %s\n", This, imagefile);
		xexit(1);
		/* NOTREACHED */
	}
	signal(SIGINT, _signalhandler);
	if (Dopt) {
		ifdim2hd(fgetc(fp), imagefile);
		tracktable = xmalloc(TRACK_COUNT);
		xfread(tracktable, sizeof(char), TRACK_COUNT, fp);
		xfread(Fat, sizeof(char), 255 - TRACK_COUNT, fp);	/* SKIP DIM header */
		if (0 != strncmp(Fat, DIFCMAGIC, 13)) {
			ifdim2hd(!DIM_2HD_ID, imagefile);
			/* NOTREACHED */
		}
		if (Copt) put_dim_info(Fat + 15);
	}
	xfseek(fp, BLOCKSIZE, SEEK_CUR);						/* SKIP IPL */
	xfread(Fat, sizeof(char), BLOCKSIZE * 2, fp);			/* read FAT */
	if (!fopt && 0 != strncmp(Fat, FDFATMAGIC, 3)) {
		fprintf(stderr, "%s: not 2HD image file: %s\n", This, file[0]);
		xfclose(fp);
		xexit(1);
		/* NOTREACHED */
	}
	xfseek(fp, BLOCKSIZE * 2, SEEK_CUR);					/* SKIP FAT2 */
	xfread(pool, sizeof(char), sizeof(DIRENT) * 192, fp);	/* read Directory Entry */
	make_seek_table();
	exdir(pool, "", (const REGEX **)&file[1], count);
	xfclose(fp);
	/* free(pool); free(Fat); free(seektable); */
	return xexit(0);
}

static void
usage(void)
{
	/*
		ŕ\ȂIvVgpꍇ
		x DOS ɑ΂mȂƁAn}ɂƂł傤B
		˂Ďgpꍇ͊e̐ӔCɉĎgpĂB
	*/
	fprintf(stderr, "usage: %s [-l1tpxijcqnoCFVAD/] [-d outputdir] imagefile [extfile] ...\n", This);
	xexit(1);
}

static int
chkarg(int argc, char **argv, char **file)
{
	int		i = 0;

	while(argc--) {
		if ('-' == **argv) {
			while(*++*argv) {
				switch(**argv) {

				case	'V':	/* version put */
					printf("dx: version %s (C) 1995 fubuki\n", rcsname);
					xexit(0);
					/* NOTREACHED */
				case	'/':	/* option all clear */
					iopt = SENSITIVE;
					Fopt = Copt = qopt = \
					jopt = fopt = popt = copt = \
					vopt = xopt = oopt = nopt = \
					topt = once = FALSE;
					outputdir = "";
					break;
				case	'i':	/* p^[ő啶 */
					iopt = INSENSITIVE;
					break;
				case	'F':	/* ls -F Ɠ */
					Fopt = TRUE;
					break;
				case	'C':	/* dim ̂ƂRgo */
					Copt = TRUE;
					break;
				case	'q':	/* ܂ */
					qopt = TRUE;
					break;
				case	'j':	/* Xn (mkdir Ȃ) */
					jopt = TRUE;
					xopt = TRUE;
					break;
				case	'f':	/* ۏ */
					fopt = TRUE;
					break;
				case	'p':	/* stdout  o */
					popt = TRUE;
					xopt = TRUE;
					jopt = TRUE;
					break;
				case	'c':	/* Human g file name(10)؂̂ */
					copt = TRUE;
					break;
				case	'v':	/* volume label o */
					vopt = TRUE;
					break;
				case	'x':	/* o */
					xopt = TRUE;
					break;
				case	'D':	/* *.dim mode (2HD(8sec) only) */
					force = DIM;
					break;
				case	'A':	/* all over (x^ mode (2HD(8sec) only)) */
					force = ALLOVER;
					break;
				case	'o':	/*  over write */
					oopt = TRUE;
					break;
				case	'n':	/*  skip */
					nopt = TRUE;
					break;
				case	't':	/* tree list */
					xopt = FALSE;
					topt = TRUE;
					once = TRUE;
					break;
				case	'1':	/* Xg */
					xopt = FALSE;
					once = TRUE;
					break;
				case	'l':	/* Xg (l) */
					xopt = FALSE;
					break;
				case	'd':	/* o path w */
					if (EOS == *++*argv) {
						++argv;
						if (0 > --argc) usage();
						/* NOTREACHED */
					}
						outputdir = chopslash(*argv);
						goto DOWN;
				default:
					usage();
					/* NOTREACHED */
				}
			}
		} else {
			if (i == 0 && match(*argv, "*.dim", INSENSITIVE)) Dopt = TRUE;
			file[i++] = *argv;
			if (i > MAXPATTERN) {
				fprintf(stderr, "%s: too many pattern\n", This);
				xexit(1);
				/* NOTREACHED */
			}
		}
		DOWN:
		++argv;
	}
	return i;
}

static void
_xmkdir(const char *buffer, const char *last, int stack)
{
	char		line[PATH_MAX], *q;
	const char	*p;

	p = buffer;
	q = line;
	while(*p) {
		if (ismbblead(*p)) {
			p += 2;
		} else if (p > last && *p == *slash) {
			*q = EOS;
			if (0 == _XMKDIR(line)) {
				PUT_EXTMESSAGE(line, "succeed\n");
				_XCHMOD(line, POPATTR(stack));
				_xutime(line, POPTIME(stack));
			}
			_xmkdir(buffer, p, ++stack);
			return;
		} else {
			*q++ = *p++;
		}
	}
}

#ifndef UTIME_EXIST
static void
_xutime(const char *name, const UL tstamp)
{
	FILE	*p;
	UL		a;

	a = _XCHMOD(name, -1);
	_XCHMOD(name, MS_REG);
	p = fopen(name, "a");
	_dos_filedate(fileno(p), tstamp);
	fclose(p);
	_XCHMOD(name, a);
}
#endif /* UTIME_EXIST */

static int
regname(char *p, const int dotpoint)
{
	int		f = FALSE;
	int		i = 0;

	while(*p) {
		if (i == dotpoint) {
			p++;
		} else if (ismbblead(*p)) {
			p += 2;
		} else if (ISTHROUGH(*p)) {
			p++;
		} else {
			*p++ = '_';
			f = TRUE;
		}
		i++;
	}
	return f;
}

/*
	т̖{(т)
 */
static int
exdir(DIRENT *pool, const char *path, const REGEX **reg, int count)
{
	char	buffer[256];
	char	*p, *q, *pathterm;
	int		i, cond, dotpoint;

	strcpy(buffer, path);
	if (EOS != *path) strcat(buffer, slash);
	pathterm = &buffer[strlen(buffer)];
	while(0 != pool->name[0]) {
		if ('\xe5' == pool->name[0]) {
			pool++;
			continue;
		}
		q = pathterm;
		p = pool->name;
		if (5 == *p) *q = 0xe5;
		else *q = *p;
		p++;
		q++;
		i = 7;
		while(i-- && (' ' != *p)) *q++ = *p++;
		if (!copt) {
			p = pool->extname;
			i = 10;
			while(i-- && (0 != *p)) *q++ = *p++;
		}
		p = pool->ext;
		dotpoint = -1;
		if (' ' != *p) {
			dotpoint = q - pathterm;
			if(!(MS_VOL & pool->attr) ||
				((MS_VOL & pool->attr) && xopt)) *q++ = '.';
			i = 3;
			while(i-- && (' ' != *p)) *q++ = *p++;
		}
		*q = EOS;

		if (0 == (strcmp(pathterm, ".")) ||
			0 == (strcmp(pathterm, ".."))) {
			pool++;
			continue;
		}

		for(i = 0; i < count; i++)
		if (match(buffer, reg[i], iopt)) {
			*newname = 0;
			cond = FALSE;
			if (xopt) {
				if(regname(pathterm, dotpoint))
					fputs("regular... ", stderr);
				if (vopt && (MS_VOL & pool->attr)) {
					FILE	*p;
					_XCHMOD(buffer, MS_REG);
					p = fopen(buffer, "w");
					PUT_EXTMESSAGE(buffer, NULL != p ? "succeed\n" : "failure\n");
					cond = NULL != p ? TRUE : FALSE;
					xfclose(p);
				} else if (MS_DIR & pool->attr) {
					if (!jopt) {
						int		n;
						if (indent) _xmkdir(buffer, buffer, 0);
						n = _XMKDIR(buffer);
						PUT_EXTMESSAGE(buffer, 0 == n ? "succeed\n" : "failure\n");
						cond = 0 == n ? TRUE : FALSE;
					}
				} else if (!(MS_VOL & pool->attr)) {
					if (!jopt && indent) _xmkdir(buffer, buffer, 0);
					cond = writefile(pool, jopt ? getname(buffer) : buffer);
				}
				if (cond && !popt) {
#if UTIME_EXIST
					struct utimbuf tm;
					tm.modtime = tm.actime = maketime(pool);
					utime(EOS != *newname ? newname :
							jopt ? getname(buffer)  : buffer, &tm);
					/*
						libc  utime  [N21?
						̂ŁAƂ肠ȉœ
					*/
#else	/* Human Local */
					_xutime(EOS != *newname ? newname :
							jopt ? getname(buffer) : buffer, REGSTAMP(pool));
#endif
					_XCHMOD(EOS != *newname ? newname :
							jopt ? getname(buffer) : buffer, pool->attr);
				}
			} else {
				if (!once) {
					struct tm tp;
					PUTATTR(pool->attr);
					printf(" %7d ", REGLEN(pool->length));
					regtime(&tp, pool);
					printf("%s %2d %02d:%02d:%02d %4d ",
						months[tp.tm_mon], tp.tm_mday,
						tp.tm_hour, tp.tm_min, tp.tm_sec,
						tp.tm_year + 1900
					);
				}
				if (topt) {
					int		i = indent;
					if (MS_DIR & pool->attr) {
						fputs("|", stdout);
						while(i--) fputs("   |", stdout);
						putchar('\n');
					}
					i = indent;
					while(i--) fputs("|   ", stdout);
					printf("|- %s", getname(buffer));
				} else
					fputs(buffer, stdout);
				if (Fopt) {
#if LS_LIKE
					int		a = MS_DIR & pool->attr ? *slash :
								MS_LNK & pool->attr ? '@'    :
								MS_EXE & pool->attr ? '*'    : 0;
					if (a) putchar(a);
					if (match(buffer, "*.[xr]", INSENSITIVE) && a != '*')
						putchar('*');
#else
					if (MS_DIR & pool->attr) putchar(*slash);
#endif /* LS_LIKE */
				}

				putchar('\n');
			}
		} /* for loop end */
		if (MS_DIR & pool->attr) {
			US	f = pool->start_fat >> 8 | pool->start_fat << 8;
			PUSHATTR(pool);
			indent ++;
			readdirs(f, buffer, reg, count);
				/* ̊֐̒Ō݂̊֐ċAI call Ă */
			indent --;
		}
		pool++;
	}
	return 0;
}

static char *
exist_interactive(char *name)
{
	char	buffer[32];
	FILE	*fp;

	fp = fopen(name, "r");
	if (NULL != fp) {
		fclose(fp);
		if (nopt) return NULL;
		fprintf(stderr, "writable %s exists; remove it? [nyr](n): ", name);
		gets(buffer);
		switch(*buffer) {

		case	'r':
			fprintf(stderr, "new name: %s -> ", name);
			gets(newname);
			name = exist_interactive(newname);
			break;

		case	'y':
#if FORCE_WRITE
			if ((MS_RED|MS_HID|MS_SYS) & _XCHMOD(name, -1)) {
				_XCHMOD(name, MS_REG);
				unlink(name);
			}
#endif /* FORCE_WRITE */
			break;

		default:
			 return NULL; 		/* "checkout aborted" */

		}
	}
	return name;
}

static int
writefile(const DIRENT *pool, char *name)
{
	FILE	*fpw;
	US		fat = pool->start_fat >> 8 | pool->start_fat << 8;
	char	buffer[BLOCKSIZE];
	UL		l, s, n = 0;
	int		verbose = FALSE;

	if (!oopt && !popt) {
		if (NULL == (name = exist_interactive(name))) return FALSE;
	}
	if (popt) {
		fpw = stdout;
		fmode(stdout, _IOBINARY);
	} else {
		if (NULL == (fpw = fopen(name, "wb"))) {
			if (EOS != *outputdir) {
				fputs(outputdir, stderr);
				fputs(slash, stderr);
			}
			fprintf(stderr, "%s: ", name);
			fputs("failure\n", stderr);
#if CONTINUE
			return FALSE;
#else
			xexit(1);
			/* NOTREACHED */
#endif
		}
		wfile = name;
			/* ݏ݃I[vĂt@C signalpɕێ */
	}
	PUT_EXTMESSAGE(name, "");
	xfseek(fp, SEEKPTR(11 + (fat - 2)), SEEK_SET);
	if ((1024 * 100) < (l = REGLEN(pool->length))) verbose = TRUE;
	s = l < BLOCKSIZE ? l : BLOCKSIZE;
	xfread(buffer, sizeof(char), s, fp);
	if (FALSE == xfwrite(buffer, sizeof(char), s, fpw)) return FALSE;
	l -= s;
	while(FATTERM12 != (fat = getfatlink(fat, Fat))) {
		xfseek(fp, SEEKPTR(11 + (fat - 2)), SEEK_SET);
		if (l < BLOCKSIZE) s = l;
		xfread(buffer, sizeof(char), s, fp);
		if(FALSE == xfwrite(buffer, sizeof(char), s, fpw)) return FALSE;
		if (!qopt && verbose && (0 == n % 32)) fputc('.', stderr);
		l -= s;
		n++;
	}
	if (!qopt) fputs(" succeed\n", stderr);
	if (!popt) xfclose(fpw);
	return TRUE;
}

static void
readdirs(int fat, const char *path, const REGEX **reg, int count)
{
	int		fats = fat;
	int		n = 1;
	char	*sub, *p;

	while(FATTERM12 != (fats = getfatlink(fats, Fat))) n++;
	p = sub = xmalloc((BLOCKSIZE * n) + 1);
	xfseek(fp, SEEKPTR(11 + (fat - 2)), SEEK_SET);
	xfread(p, sizeof(char), BLOCKSIZE, fp);
	p += BLOCKSIZE;
	while(FATTERM12 != (fats = getfatlink(fat, Fat))) {
		xfseek(fp, SEEKPTR(11 + (fats - 2)), SEEK_SET);
		xfread(p, sizeof(char), BLOCKSIZE, fp);
		p += BLOCKSIZE;
		fat = fats;
	}
	*(sub + BLOCKSIZE * n) = SENTINEL;
	exdir((DIRENT *)sub, path, reg, count);
	free(sub);
}

/* 12bit FAT only */
static int
getfatlink(const int fatno, const char *fat)
{
	UC		*p = (UC *)fat;
	int		offset, off, link;

	offset = fatno * 15;
	off = offset / 10;
	if (5 == offset % 10) {
		link =  *(p + off + 1) << 4;
		link += ((*(p + off) >> 4) & 017);
	} else {
		link =  (*(p + off + 1) & 017 ) << 8;
		link += *(p + off);
	}
	return link;
}

static void
regtime(struct tm *tp, const DIRENT *pool)
{
	tp->tm_sec = ((pool->time >> 8) & 037) * 2;
	tp->tm_min = (pool->time >> 13) | ((pool->time << 3) & 070);
	tp->tm_hour = (pool->time >> 3 ) & 037;
	tp->tm_mday = (pool->date >> 8) & 037;
	tp->tm_mon = (((pool->date >> 13) & 07) | ((pool->date << 3) & 010)) - 1;
	tp->tm_year = ((pool->date >> 1) & 0177) + 80;
	tp->tm_isdst = -1;

	if (!ISMONTHS(tp->tm_mon)) tp->tm_mon = 12;
}

#if UTIME_EXIST
static time_t
maketime(const DIRENT *pool)
{
	struct tm n;

	regtime(&n, pool);
	return mktime(&n);
}
#endif /* UTIME_EXIST */

static void *
xmalloc(size_t foo)
{
	void	*p;
	if (NULL == (p = malloc(foo))) {
		fprintf(stderr, "%s: memory exhausted\n", This);
		xexit(1);
		/* NOTREACHED */
	}
	return p;
}

static int
xfseek(FILE *fp, long offset, int whence)
{
	int		n;
	if (0 > (n = fseek(fp, offset, whence))) {
		fprintf(stderr, "%s: file seek error\n", This);
		xexit(1);
		/* NOTREACHED */
	}
	return n;
}

static int
xfread(void *buffer, size_t so, size_t size, FILE *fp)
{
	int		n;
	n = fread(buffer, so, size, fp);
	if ((n < (so * size)) || (0 != ferror(fp))) {
		fprintf(stderr, "%s: file read error\n", This);
		fclose(fp);
		xexit(1);
		/* NOTREACHED */
	}
	return n;
}

static int
xfwrite(void *buffer, size_t so, size_t size, FILE *fp)
{
	int		n;
	n = fwrite(buffer, so, size, fp);
	if ((n < (so * size)) || (0 != ferror(fp))) {
#if CONTINUE
		fputs(" failure\n", stderr);
		n = FALSE;
		fclose(fp);
		unlink(wfile);
		wfile = "";
#else
		fprintf(stderr, "%s: file write failure\n", This);
		fclose(fp);
		unlink(wfile);
		xexit(1);
		/* NOTREACHED */
#endif /* CONTINUE */
	} else {
		n = TRUE;
	}
	return n;
}

static void
xfclose(FILE *fp)
{
	if (0 != fclose(fp)) {
		fprintf(stderr, "%s: file close failure\n", This);
		xexit(1);
		/* NOTREACHED */
	}
	wfile = "";
}

static int
match(const char *str, const REGEX *ptn, CASE icase)
{
	while(*ptn) {

		/* ꂪȂ "ZIP"  "*P?*" Ȃǂ}b`Ă܂ */
		if (EOS == *str && ANYSTRING != *ptn)
			return FALSE;

		switch(*ptn) {

	    case	ANYCHAR:
	    	ptn++;
	    	if (ismbblead(*str) && EOS != str[1])
	    		str += 2;
	    	else
	    		str++;
	    	break;
	    case	ANYSTRING:
			ptn++;
			while(*str) {
				if (match(str, ptn, icase)) return TRUE;
				if (ismbblead(*str) && EOS != str[1]) str++;
				str++;
			}
			if (match("", ptn, icase)) return TRUE;
			return FALSE;
			break;
#if defined(METASLASH) && defined(METABACKSLASH)
		/*
			METASLASH = / , METABACKSLASH = \ ɂ邱Ƃɂ
			"/"  "\"  "/" ɂ "\" ɂ}b`郁^ɂȂ
			 ESCAPE  "\" ȊOɕύXȂ΂Ȃ
		*/
	    case	METASLASH:
	    case	METABACKSLASH:
			if (!ISSLASH(*str)) return FALSE;
			str++;
			ptn++;
			break;
#endif /* METASLASH && METABACKSLASH */
		case	LBRACKET:
		{
			int		cc, c, h, l, not = FALSE, cnd = FALSE;
			ptn++;
			if (UNSET_OLD == *ptn || UNSET == *ptn) {
				ptn++;
				cnd = not = TRUE;
			}
			c = GETCHAR(str, icase);
			if (RBRACKET == *ptn && RBRACKET == c) {
				cnd = !cnd;
				ptn++;
				while(RBRACKET != *ptn && *ptn) {
					if (ismbblead(*ptn) && EOS != ptn[1]) ptn++;
					ptn++;
				}
				goto DOWN;
			}
			while(RBRACKET != *ptn && *ptn) {
				h = l = GETCHAR(ptn, icase);
				if (RANGE == *ptn) {
					ptn++;
					if (RBRACKET == *ptn || EOS == *ptn) return FALSE;
					h = GETCHAR(ptn, icase);
				}
				cc = not ? !(c >= l && c <= h) : (c >= l && c <= h);
				if (not) {
					cnd &=  cc;
				} else if (cc) {
					cnd = cc;
					while(RBRACKET != *ptn && *ptn) {
						  if (ismbblead(*ptn) && EOS != ptn[1]) ptn++;
						  ptn++;
					}
					break;
				}
			}
DOWN:
			if ((RBRACKET != *ptn++) || (!cnd)) return FALSE;
			break;
		}
#if defined(LBRACE) && defined(RBRACE)
		case	LBRACE:
		{
			const char	*p, *q;
			int		mt, wp, ws;
			if (!*str) return FALSE;
			q = p = str;
			ptn++;
			do {
				str = p;
				mt = TRUE;
				do {
					if (EOS == *ptn) return FALSE;
					ws = GETCHAR(str, icase);
					wp = GETCHAR(ptn, icase);
					if (ws != wp) {
						mt = FALSE;
						while(RBRACE != *ptn && ',' != *ptn && *ptn) {
							if (ismbblead(*ptn) && EOS != ptn[1]) ptn++;
							ptn++;
						}
					}
				} while (RBRACE != *ptn && ',' != *ptn);
				if (TRUE == mt && str - p > q - p) {
					q = str;
				}
				if (',' == *ptn) ptn++;
			} while (RBRACE != *ptn);
			if (q == p) return FALSE;
			ptn++;
			str = q;
			break;
		}
#endif /* defined(LBRACE) && defined(RBRACE) */
	    default:
	    {
	    	int		p, s;
	    	p = GETCHAR(ptn, icase);
	    	s = GETCHAR(str, icase);
			if (escape_char == p) p = GETCHAR(ptn, icase);
			if (p != s) return FALSE;
			break;
		}

	  }
	}
	return *str ? FALSE : TRUE;
}

static void
xchdir(const char *path)
{
	extern	errno;
	static char	oldpwd[PATH_MAX];

	if (0 == (strcmp(path, "-"))) {
		path = (const char *)oldpwd;
	}
	strcpy(oldpwd, _getpwd());
	if (-1 == chdir(path)) {	/* : JghCuύX chdir */
		switch(errno) {

		case	ENOENT:
			fprintf(stderr, "%s: directory not found: %s\n", This, path);
			break;
		case	ENOTDIR:
			fprintf(stderr, "%s: bad directory name: %s\n", This, path);
			break;
		case	ELOOP:
			fprintf(stderr, "%s: deep nest symbolic link: %s\n", This, path);
			break;

		}
		xexit(1);
		/* NOTREACHED */
	}
	return;
}

static void
make_seek_table(void)
{
	short	*p = seektable = xmalloc(sizeof(short) * OFFSET_MAX);
	char	*t = tracktable;
	int		i, j, k;

	if (Dopt) {
		dimoffset = 256;
		for(k = i = 0; i < TRACK_COUNT; i++, t++) {
			for(j = 0; j < SECTOR; j++) {
				*p++ = *t ? k++ : k ;
			}
		}
		free(tracktable);	/* Ȃ */
	} else {
		for(i = 0; i < OFFSET_MAX; i++) *p++ = i;
	}
}

static void
ifdim2hd(int a, const char *name)
{
	if (DIM_2HD_ID != a) {
		fprintf(stderr, "%s: not 2HD dim format: %s\n", This, name);
		xfclose(fp);
		xexit(1);
		/* NOTREACHED */
	}
}

static void
put_dim_info(const char *p)
{
	int		y, m, d, h, mm, s;

	y = *++p;	m = *++p;	d = *++p;	++p;
	h = *++p;	mm = *++p;	s = *++p;
	printf("%s %2d %02d:%02d:%02d %4d %s\n",
				months[BCD2DIGIT(m) - 1],
				BCD2DIGIT(d),	BCD2DIGIT(h),
				BCD2DIGIT(mm),	BCD2DIGIT(s),
				BCD2DIGIT(y) + 1980, ++p);
}
static char *
chopslash(char *name)
{
	char	*p = name;
	while(*p) {
		if (ismbblead(*p)) {
			p += 2;
			continue;
		}
		if ((1 == strlen(p)) && ISSLASH(*p)) {
			*p = EOS;
			break;
		}
		p++;
	}
	return name;
}

static char *
_getpwd(void)
{
#if NO_PWD_ENV
	static char	p[PATH_MAX], *q;
	q = p;
	*q++ = _dos_curdrv() + 'A';
	*q++ = ':';
	*q++ = *slash;
	_dos_curdir(0, q);
	q = p;
	while(*q) {
		if (ismbblead(*q)) {
			q += 2;
			continue;
		}
		if (ISSLASH(*q)) *q = *slash;
		q++;
	}
	*q = EOS;
	return p;
#else
	return getenv("PWD");
#endif
}

static char *
getname(const char *p)
{
	char	*q = (char *)p;

	while(*p) {
		if (ismbblead(*p)) {
			p += 2;
			continue;
		}
		if (ISPATH(*p)) q = (char *)p+1;
		p++;
	}
	return q;
}

static void
_signalhandler(int sig)
{
	fcloseall();
	if (!popt || (EOS != *wfile)) _dos_delete(wfile);
	if (EOS != *outputdir) xchdir("-");
	_dos_print("aborted\r\n");
	xexit(2);
}

static int
xexit(const int n)
{
	if (EOS != *outputdir) xchdir("-");
	exit(n);
	return 0;	/* for `main' exit dummy */
}

/*** dx.c ***/
